// Compiler avec gcc -g -Wall --param ssp-buffer-size=200 ChangeUser.c -lcrypt -o ChangeUser.bin
#define _XOPEN_SOURCE
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <pwd.h>
#include <shadow.h>

#define TAILLE_BUFF 50

int verif(const char* nom) {
  char pass[TAILLE_BUFF];
  char salt[TAILLE_BUFF];

  struct spwd *sp;
  char *passcrypt;
  int i;
  int res = 0;
  
  fprintf(stdout, "Mot de passe de %s : ", nom);
  system("stty -echo");
  fscanf(stdin, "%s", pass);
  system("stty echo");

  sp = getspnam(nom);
  if (sp == NULL) {
    perror("Impossible car : ");
    return res;
  }
  
  if (!((sp->sp_pwdp[0] == '$')
	&&(sp->sp_pwdp[2] == '$'))
      ) {
    fprintf(stderr, "Impossible !");
    return res;
  }
  salt[0] = sp->sp_pwdp[0];
  salt[1] = sp->sp_pwdp[1];
  salt[2] = sp->sp_pwdp[2];
  i = 3;
  while ((sp->sp_pwdp[i] != '\0')&&(sp->sp_pwdp[i] != '$')) {
    salt[i] = sp->sp_pwdp[i];
    i++;
  }
  salt[i++] = '$';
  salt[i] = '\0';
  if (sp->sp_pwdp[i] == '\0') {
    fprintf(stderr, "Impossible !");
    return res;
  }
    
  
  passcrypt = crypt(pass, salt);
  
  if (strcmp(passcrypt,sp->sp_pwdp) == 0) {
    fprintf(stdout, "Mot de passe correct\n");
    res = 1;
  } else {
    fprintf(stdout, "Mot de passe incorrect\n");
  }

  return res;

}



int main(int argc, char* argv[]) {
  int res;
  char *nom;
  struct passwd *pw;

  if (argc != 2) {
    fprintf(stderr, "Usage %s <nom d'utilisateur>\n", argv[0]);
    exit(1);
  }
  nom = argv[1];

  res = verif(nom);

  if (res) {
    pw = getpwnam(nom);
    if (pw == NULL) {
      perror("Problème l'utilisateur n'existe pas");
      exit(1);
    }
    if (setgid(pw->pw_gid) < 0) {
      perror("probleme setgid");
    }
    if (setuid(pw->pw_uid) < 0) {
      perror("probleme setuid");
    }
    //    execl("/bin/su", "/bin/su/", "-c", "bash", "-l", argv[1], NULL);
    execl(pw->pw_shell, pw->pw_shell, NULL);
    perror("Probleme exec");
  }
  fprintf(stdout, "sorry !\n");

  return 0;
}
